/*global define*/

define([
	'jquery',
	'underscore',
	'backbone',
	'pcorelib'
], function ($, _, Backbone, pcorelib) {
	'use strict';
	return {

		registerEvents: function() {
			var self = this;
			pcorelib.EventChannel.on('error', function(id){
				self.throwError(id);
			});
			pcorelib.EventChannel.on('error:message', function(message){
				self.showErrorMessage(message);
			});
			pcorelib.EventChannel.on('error:hide', function() {
				self.hideErrorMessage();
			});
		},

		throwError: function(id) {
			// TODO: id zu errorText mappen
			// default-Wert 1000 ?
			// prepareBooking 1001 ?
			// performBooking 1002 ?
			// how to compile lacals: Handlebars.compile('{{t ""}}');
			var errorText = id; // debugging
			this.showErrorMessage(errorText);
		},

		/* @param: errorText
		*	JSON object in namespace
		*/
        showErrorMessage: function(errorText) {
        	if($('#errorMessage').hasClass('hideErrorMessage')) {
				$('#errorMessage').removeClass('hideErrorMessage').addClass('showErrorMessage');
			}
			$('#errorMessage').find('.errorText').html(errorText);
			$('#errorMessage').find('button').html('OK');
        },

        hideErrorMessage: function() {
        	if($('#errorMessage').hasClass('showErrorMessage')) {
				$('#errorMessage').removeClass('showErrorMessage').addClass('hideErrorMessage');
			}
        }
    }
});
