/*global define*/

define([
    'jquery',
    'underscore',
    'backbone',
    'templates',
    'pcorelib'
], function ($, _, Backbone, JST, pcorelib) {
    'use strict';
    return pcorelib.BaseView.extend({

        ContentViewClass: pcorelib.BaseView.extend({
            render: function () {
                var self = this;
                pcorelib.BaseView.prototype.render.call(this);
                _.each(this.model.lines, function(line){
                    var rLineIcon = '';
                    if(line.rLineClass&&line.lineId&&line.rIconColor) {
                        rLineIcon = '<div id="'+line.lineId+'_icon" class="line_info_icon '+line.rLineClass+'" style="float: right; color:'+line.rIconColor+';"></div>';
                    }
                    if(line.lineId) {
                        self.$el.append('<div id="'+line.lineId+'" class="click_line '+line.classes+'">'+line.text+rLineIcon+'</div>');
                    } else {
                        self.$el.append('<div class="click_line '+line.classes+'">'+line.text+rLineIcon+'</div>');
                    }
                });
                return this;
            },
            events: {
                'click' : 'clicked'
            }
        }),

        contentView: null,

        parentInstance: null,
        tagName: 'li',
        hbsTemplate: 'InfoPanel',
        alternateTemplatePath: './scripts/components/',

        callbackItemClicked: null,
        callbackIconClicked: null,

        events: {
            'click .bookee_list_item_content' : 'itemClicked',
            'click .click_icon' : 'iconClicked',
			'click .bookee_list_item_header' : 'panelClicked'
        },

		panelClicked: function(ev) {
			if(this.model.toggleMode) {
				$(ev.currentTarget).parent().find('.panel-body').toggle();
			}
		},

        model: {
            index: -1,
            group: -1,
            panelTitle: 'Dummy',
            hasAction: false,
            iconColor: ewaIconColor,
            iconClasses: 'glyphicon glyphicon-info-sign'
        },

        renderTo: function(parent) {
            this.setTemplateFacoryIfNull(app.applicationView.templateFactory);
            parent.append(this.$el);
            this.render();
        },

        render: function () {
            var self = this;
            if(!this.contentView) {
                this.contentView = new this.ContentViewClass();
            }
            this.contentView.setTemplateFacoryIfNull(app.applicationView.templateFactory);
            if(this.callbackIconClicked) {
                this.model.hasAction = true;
            }
            pcorelib.BaseView.prototype.render.call(this);
            if(this.model.index>-1) {
                this.$el.find('.click_icon').attr("group",this.model.group);
                this.$el.find('.bookee_list_item_content').attr("group",this.model.group);
                this.$el.find('.click_icon').attr("value",this.model.index);
                this.$el.find('.bookee_list_item_content').attr("value",this.model.index);
            }
            if(this.contentView) {
                this.$el.find('.bookee_list_item_content').empty();
                this.contentView.updateModel(this.model);
                this.$el.find('.bookee_list_item_content').html(this.contentView.render().el);
            }
			if(this.model.toggleClosed) {
				//this.$el.find('.panel-body').toggle();
			}

            setTimeout(function() {
                var headers = document.getElementsByClassName('bookee_list_item_header');
                var titles = document.getElementsByClassName('panel_title');
                _.each(headers, function(header) {
                    var textWidth = header.clientWidth - 18 - 22 - 15;
                    $($(header).find('.panel_title')[0]).css({'max-width':textWidth, 'text-overflow':'ellipsis'});
                });
            }, 50);
        },

        initialize:function(options){
            this.parentInstance = options.parentInstance;
            this.callbackItemClicked = options.itemClicked;
            this.callbackIconClicked = options.iconClicked;
            if(options.contentView) {
                this.contentView = options.contentView;
            }
        },

        itemClicked: function(ev) {
            event.stopPropagation();
            if(this.callbackItemClicked) {
                this.callbackItemClicked(ev,$(ev.currentTarget).attr('value'),$(ev.currentTarget).attr('group'));
            }
        },

        iconClicked: function(ev) {
            event.stopPropagation();
            if(this.callbackIconClicked) {
                this.callbackIconClicked(ev,$(ev.currentTarget).attr('value'),$(ev.currentTarget).attr('group'));
            }
        }

    });
});
