/*global define*/

define([
    'jquery',
    'underscore',
    'backbone',
    'templates',
    'pcorelib'
], function ($, _, Backbone, JST, pcorelib) {
    'use strict';
    return pcorelib.BaseView.extend({

        hbsTemplate: 'collapsePanel',
        alternateTemplatePath: './scripts/components/',

        events: {
            'click' : 'clickEvent',
            "click .panel-heading": "panelClicked"
        },

        panelClicked: function(ev) {
            $(ev.currentTarget).parent().find('.panel-body').toggle();
        },

        render: function() {
			var self = this;
            this.setTemplateFacoryIfNull(app.applicationView.templateFactory);
            pcorelib.BaseView.prototype.render.call(this);
				
				if (this.model.panelViews) {
					_.each(this.model.panelViews, function(panelView){
						self.renderView(panelView, true);
					});
				}
				
            if(this.model.panelView) {
                self.renderView(this.model.panelView);
            }
        },
		  
		renderView: function(panelView, multiview) {
			var self = this;
			multiview = multiview || false;
			panelView.setTemplateFacoryIfNull(app.applicationView.templateFactory);
			panelView.render();
			if (!multiview) {
				self.$el.find('.panel-body').empty();
			}
			var panelContent = self.$el.find('.panel-body').append(panelView.el);
			if (self.model.panelOpen) {
				panelContent.show();
			}
		}
    });
});
