/*global require*/
'use strict';

var ewaIconColor = '#2D71C1';

require.config(requireConfig);

/*
 * Global Application-Context
 */
var overrideLoginForTesting = false;

var app = null;
var isHomeView = false;

require([

    'backbone',
    'bootstrap',
    'bootstrapalert',
    'i18next',
    'moment',

    'pcorelib',

    'views/application/EWAApplicationView',

    'application/EWAApplication',
    'routes/EWAMainRouter',
    'requests/EWARequestFactory',

    'markercluster',
    'bootstrapmodal',
    'bootstrapmodalmanager'

], function (Backbone, Bootstrap, Bootstrapalert, i18n, moment, pcorelib, EWAApplicationView, EWAApplication, EWAMainRouter, EWARequestFactory) {

    /*
     * Load EWA-Application-Configuration
     */
    app = new EWAApplication();

    app.build({
        configurationPath: "./scripts/configuration/InitialApplicationConfig.json",
        configurationIdentifier: {"id":"appConfig001"}
    },function() {

        setTimeout(function(){
          i18n.init({
                lng: app.data.langParameters.selectedLang,
                fallbackLng: false,
                resGetPath: 'locales/__lng__/__ns_____lng__.json',
                ns: { namespaces: ['000-login', '000-login-help']},
                debug: true
            }, function () {

                console.log("done loading i18n");

                app.postBuildSetup({
                    applicationRouter: new EWAMainRouter(),
                    applicationView: new EWAApplicationView(),
                    requestFactory: new EWARequestFactory()
                });
                app.initServices();
                app.buildAuth();

                Handlebars.registerHelper('t', function(i18n_key) {
                    var result = i18n.t(i18n_key);
                    return new Handlebars.SafeString(result);
                });

                Handlebars.registerHelper('select', function( value, options ){
                    var $el = $('<select />').html( options.fn(this) );
                    $el.find('[value=' + value + ']').attr({'selected':'selected'});
                    return $el.html();
                });

                //call to begin monitoring uri and route changes
                Backbone.history.start();

                $("body").i18n();
                app.applicationRouter.trigger("i18:initialized");

            });
        }, 1000);

    });

});
