/**
 * Created by vkusmin on 14.07.15.
 */
define([
    'jquery',
    'underscore',
    'backbone',
    'templates',
    'pcorelib'
], function ($, _, Backbone, JST, pcorelib) {
    'use strict';
    return pcorelib.BaseView.extend({
        hbsTemplate: 'BookeeCostPanelView',
        alternateTemplatePath: './scripts/templates/bookees/',
        events:{
            "click #bookeeCalcCostBtn":  "calcCost",
            "click #bookeeCostInput": "handleInput"
        },
        calcCost: function(event) {
			var self = this;
            event.preventDefault();
            this.model.distValue = $("#bookeeCostInput").val();
            this.model.fullPrice = 0;
            this.listenToOnce(app.requestFactory,'compute_ride_price_of_booking:success',function(response){
                app.estimatedPrice = response.result.priceInfo;
                this.model.estimatedCost = app.estimatedPrice;
                console.log(JSON.stringify(response));
                this.calculateValues(this.model.estimatedCost.priceItems);
                this.render();
            });
				this.listenToOnce(app.requestFactory,'compute_ride_price_of_booking:error',function(response){
					app.estimatedPrice = null;
					this.model.estimatedCost = null;
					this.render();
				});

            var userParams = JSON.parse(JSON.stringify(app.auth.fullAuthentication));
            userParams.parameters = {"hash":self.model.bookPrelimHash, "distance":parseInt($("#bookeeCostInput").val().match(/\d+/)[0])};
            app.requestFactory.performRequest('compute_ride_price_of_booking',userParams,new Backbone.Collection());

        },

        handleInput:function(event){
            event.preventDefault();
            event.stopPropagation();
            return false;
        },
        calculateValues:function(prices){
            try {
                for(var i =0; i<prices.length; i++){
                    var price=prices[i];
                    if(price.value && price.vatValue){
                        var floatValue = parseFloat(price.value);
                        price.calculatedValue = floatValue.toFixed(2);
                        var fullFloatValue = parseFloat(this.model.fullPrice) + floatValue;
                        this.model.fullPrice = parseFloat(fullFloatValue).toFixed(2);
                    }
                }
            } catch (err) {
                console.log(err);
            }
        }
    });
});
