/**
 * Created by vkusmin on 14.07.15.
 */
define([
    'jquery',
    'underscore',
    'backbone',
    'templates',
    'pcorelib'
], function ($, _, Backbone, JST, pcorelib) {
    'use strict';
    return pcorelib.BaseView.extend({
        hbsTemplate: 'BookingRemarkPanelView',
        alternateTemplatePath: './scripts/templates/bookings/',
        events:{
            "click #bookingChgRemarkBtn":  "changeBookingRemark",
            "click #bookingRemarkInput": "handleInput",
            "click #bookingCancelRemarkBtn": "cancelRemarkChange",
            "click #bookingConfirmRemarkBtn": "confirmRemarkChange"
        },

        render: function () {
            if(this.model.bookingRemark && this.model.bookingRemark != "" && this.model.bookingRemark != null){
                this.model.remarkExists = true;
            } else {
                this.model.remarkExists = false;
            }
            var self = this;
            pcorelib.BaseView.prototype.render.call(this);
        },

        changeBookingRemark: function(event) {
            this.model.editMode = true;
            this.render();
        },

        cancelRemarkChange: function(event) {
            this.model.editMode = false;
            this.render();
        },

        confirmRemarkChange: function(event) {
            var self = this;
			event.preventDefault();
			this.model.distValue = $("#bookeeCostInput").val();
			this.model.fullPrice = 0;
			this.listenToOnce(app.requestFactory,'add_booking_remark:success', function (response){
				this.model.bookingRemark = $("#bookingRemarkInput").val();
				if(this.model.bookingRemark == null || this.model.bookingRemark == "") {
					this.model.remarkExists = false;
				} else {
					this.model.remarkExists = true;
				}
				this.model.editMode = false;
				this.render();
			});
			this.listenToOnce(app.requestFactory,'add_booking_remark:error', function (response){
				pcorelib.EventChannel.trigger('error', $.t('999-err-msg:code.'+response.responseJSON.errorCode));
				this.model.editMode = false;
				this.render();
			});

			var userParams = JSON.parse(JSON.stringify(app.auth.fullAuthentication));
			userParams.parameters = {
				"orgNr":self.model.orgNr,
				"seqInOrg":self.model.seqInOrg,
				"bookingRemark":$("#bookingRemarkInput").val()
			};
			app.requestFactory.performRequest('add_booking_remark',userParams,new Backbone.Collection());
        },

        handleInput:function(event){
            event.preventDefault();
            event.stopPropagation();
            return false;
        },

        calculateValues:function(prices){
            for(var i = 0; i < prices.length; i++){
                var price = prices[i];
                if(price.value && price.vatValue){
                    price.calculatedValue = Math.ceil(price.value) + Math.ceil(price.value/100*price.vatValue);
                    this.model.fullPrice += price.calculatedValue;
                }
            }
        }
    });
});
