/*global EWAAppNeu, Backbone, JST*/

define([
		'jquery',
		'underscore',
		'backbone',
		'templates',
		'pcorelib'
	],

	function ($, _, Backbone, JST, pcorelib) {
		'use strict';
		return pcorelib.BaseView.extend({
			tagName: "div",
			className: "form-group",
			hbsTemplate: 'SelectionView',
			alternateTemplatePath: './scripts/templates/components/',

			events: {
				"change #localSelection": "selectionEvent",
				"click #addSelectionBtn": "addButton"
			},

			array: [],

			initialize: function (options) {
				var self = this;
				pcorelib.BaseView.prototype.initialize.call(this,options);
				this.model.array = [];
				_.each(this.model.values,function(value){
					self.model.array.push(self.mapValue(value));
				});
                $(window).on("resize", self.orientationChanged.bind(self));
			},

			selectValue: function(value) {
				for (var i = 1; i < this.model.array.length; i++) {
					var currentValue = this.model.array[i].value;
					if(value==currentValue) {
						this.model.array[i].selected = true;
					} else {
						this.model.array[i].selected = false;
					}
				}
				this.render();
			},

			render: function() {
				var self = this;
				pcorelib.BaseView.prototype.render.call(this);
				if(self.getDefaultValue) {
					self.valueSelected(self.getDefaultValue());
				} else {
					var abc = this.$el.find("#localSelection option:selected");
					var index = (abc.length>0)?abc[0].id:0;
					self.valueSelected(this.model.values[index]);
				}
				if(self.model.addButton) {
					this.$el.find('#buttonSection').css('display','block');
					this.$el.find('#selectionCol').width($('#appContent').innerWidth()-50);
				} else {
					this.$el.find('#selectionCol').width($('#appContent').innerWidth()-12);
					this.$el.find('#selectionCol').addClass("withoutAddButton");
				}
				return this;
			},

			getDefaultValue: null,

			addButton: function() {
			},

			orientationChanged: function(){
                if(this.model.addButton) {
                    this.$el.find('#selectionCol').width($('#appContent').innerWidth()-50);
                } else {
                    this.$el.find('#selectionCol').width($('#appContent').innerWidth()-12);
                }
			},

			valueSelected: function(value) {

			},

			valuePreSelected: function(value) {

			},
			
			updateValues: function (values) {
				var self = this;
				
				self.model.array = [];
				_.each(values,function(value){
					self.model.array.push(self.mapValue(value));
				});
				
				self.$el.replaceWith(self.render().$el);
			},

			selectionEvent: function(ev) {

				var self = this;

				var selected = $(ev.currentTarget).find("option:selected")[0];

				setTimeout(function(){

					var index = selected.id;

					self.valueSelected(self.model.values[index]);


				}, 500);

			},

			mapValue: function(value) {
				return value;
			}

		});
	});
