/*global define*/

define([
    'jquery',
    'underscore',
    'backbone',
    'templates',
    'pcorelib',
    'components/InfoPanel',
    'moment'
], function ($, _, Backbone, JST, pcorelib, InfoPanel, moment) {
    'use strict';
    return pcorelib.BaseView.extend({

        hbsTemplate: 'PlaceEditView',
        alternateTemplatePath: './scripts/templates/settings/',
        id: 'PlaceEditView',
        events:{
            "click #confirmChangeBtn":  "confirmChange",
            "click #cancelChangeBtn":  "cancelChange"
        },

        confirmChange: function(event) {
            var self = this;
            event.preventDefault();
            var index = self.model.index;

            var places = JSON.parse(JSON.stringify(app.userFavPlaces.places));

            if($("#inputPlacename-" + index).val() != "") {
                places[index].name = $("#inputPlacename-" + index).val();
            } else {
                pcorelib.EventChannel.trigger('error:message', $.t("550-settings-loc-edit:txt.err"));
            }

            places[index].geoRange.range = parseInt($('#rangeSelection-' + index).val());

            _.each($('.defaultCb'), function (cb, index){
                if($(cb).is(":checked")) {
                    places[index].defaultPlace = true;
                } else {
                    places[index].defaultPlace = false;
                }
            });
            app.userFavPlaces.places = places;
            pcorelib.EventChannel.trigger("place:changed:" + index, index, places);
        },

        cancelChange: function(ev) {
            var classes = $(ev.currentTarget).attr('class');
            var index = this.getIndexInClasses(classes);
            
            if(this.model.toggleMode) {
                $('.panel-body').eq(index).toggle();
            }
        },

        getIndexInClasses: function(classes) {
            var index = classes.match(/\d/g).join('');
            return index;
        }
    });
});
