/*global define*/

define([
    'jquery',
    'underscore',
    'backbone',
    'templates',
    'pcorelib',
    './SettingsPlacesView',
    './SettingsFilterView',
    'components/InfoPanel',
    'moment'
], function ($, _, Backbone, JST, pcorelib, SettingsPlacesView, SettingsFilterView, InfoPanel, moment) {
    'use strict';
    return pcorelib.BaseView.extend({

        hbsTemplate: 'SettingsView',
        alternateTemplatePath: './scripts/templates/settings/',
        id: 'SettingsView',
        events:{
            "click #showMyPlacesBtn":  "settingsButtonClicked",
            "click #showMyFiltersBtn": "settingsButtonClicked"
        },
        showPlaces:true,

        build: function() {
            var self = this;
            this.model = {
                placesActive: self.showPlaces
            };
            this.trigger('view:initialized');
        },

        renderView: function() {
            var self = this;
            var currentView;
            if(self.showPlaces){
                currentView = new SettingsPlacesView();
                currentView._templateFactory = app.templateFactory;
                self.$el.find('#settingsContainer').html(currentView.render().$el);
            } else if(!self.showPlaces) {
                currentView = new SettingsFilterView();
                currentView._templateFactory = app.templateFactory;
                self.$el.find('#settingsContainer').html(currentView.render().$el);
            }
        },

        render: function () {
			if(app.embeddedMode) {
				$('#appContent').css('visibility','inherit');
			}
            pcorelib.BaseView.prototype.render.call(this);
            var self = this;

            self.renderView();
            
            $('#outerSettingsDiv').css('height', $('#appContent').height() + 'px');

            if(app.embeddedMode){
	            var scrollHeight = document.getElementById('SettingsView').scrollHeight;
	            $('#SettingsView').css('height', (scrollHeight + 50) + 'px');
	            parent.postMessage('CANTAMEN-FRAME-LOADED:' + (scrollHeight + 50), '*');
	            pcorelib.EventChannel.trigger('app:busy:false');
			}
            return this;
        },

        settingsButtonClicked: function(event) {
            if($(event.target)[0].id.toLowerCase().indexOf("places") != -1) {
                this.showPlace(true);
                this.renderView();
            } else {
                this.showPlace(false);
                this.renderView();
            }
        },

        showPlace: function(status) {
            this.showPlaces = status;
        }

    });
});
