<?php

/**
 * AJAX Cross Domain (PHP) Proxy 0.7
 * by Iacovos Constantinou (http://www.iacons.net)
 *
 * Released under CC-GNU GPL
 */

/**
 * Enables or disables filtering for cross domain requests.
 * Recommended value: true
 */
define('CSAJAX_FILTERS', false);

/**
 * If set to true, $valid_requests should hold only domains i.e. a.example.com, b.example.com, usethisdomain.com
 * If set to false, $valid_requests should hold the whole URL ( without the parameters ) i.e. http://example.com/this/is/long/url/
 * Recommended value: false (for security reasons - do not forget that anyone can access your proxy)
 */
define('CSAJAX_FILTER_DOMAIN', FALSE);

/**
 * Set debugging to true to receive additional messages - really helpful on development
 */
define('CSAJAX_DEBUG', TRUE);

/**
 * A set of valid cross domain requests
 */
$valid_requests = array('planeta-tv.com', 'solutions.brightcove.com', 'auth.portal-test.planeta-tv.com', 'portal.planeta-tv.com', 'portal-test.planeta-tv.com');

/* * * STOP EDITING HERE UNLESS YOU KNOW WHAT YOU ARE DOING * * */

// identify request headers
$request_headers = array();
foreach (apache_request_headers() as $key => $value) {
	if (substr($key, 0, 5) == 'HTTP_') {
		$headername = str_replace('_', ' ', substr($key, 5));
		$headername = str_replace(' ', '-', ucwords(strtolower($headername)));
		}else{
			$headername = $key ;
		}
	if ($headername ==  "CONTENT_TYPE" || $headername ==  "Accept" ||  $headername == "Authorization" || $headername =="Content-Type") {
			$request_headers[] = "$headername: $value";
	}
	//}
}

//if(urldecode($_REQUEST['csurl']) == "http://v2.api.portal-test.planeta-tv.com/users/125819/tv-channels")
//csajax_debug_message(print_r(apache_request_headers()));
// identify request method, url and params
$request_method = $_SERVER['REQUEST_METHOD'];
$test=json_decode(file_get_contents('php://input'),true);
//csajax_debug_message(var_dump($test));//print_r($test)
//foreach($test as $key => $value) {
//    csajax_debug_message( $key);
//}
$request_params =  $_POST;//($request_method == 'GET') ? $_GET :
$request_url = urldecode($_REQUEST['csurl']);
$p_request_url = parse_url($request_url);
unset($request_params['csurl']);


// ignore requests for proxy :)
if (preg_match('!' . $_SERVER['SCRIPT_NAME'] . '!', $request_url) || empty($request_url) || count($p_request_url) == 1) {
	csajax_debug_message('Invalid request - make sure that csurl variable is not empty');
	exit ;
}

// check against valid requests
if (CSAJAX_FILTERS) {
	$parsed = $p_request_url;
	if (CSAJAX_FILTER_DOMAIN) {
		if (!in_array($parsed['host'], $valid_requests)) {
			csajax_debug_message('Invalid domain - ' . $parsed['host'] . ' does not included in valid requests');
			exit ;
		}
	} else {
		$check_url = isset($parsed['scheme']) ? $parsed['scheme'] . '://' : '';
		$check_url .= isset($parsed['user']) ? $parsed['user'] . ($parsed['pass'] ? ':' . $parsed['pass'] : '') . '@' : '';
		$check_url .= isset($parsed['host']) ? $parsed['host'] : '';
		$check_url .= isset($parsed['port']) ? ':' . $parsed['port'] : '';
		$check_url .= isset($parsed['path']) ? $parsed['path'] : '';
		if (!in_array($check_url, $valid_requests)) {
			csajax_debug_message('Invalid domain - ' . $request_url . ' does not included in valid requests');
			exit ;
		}
	}
}

// append query string for GET requests
if ($request_method == 'GET' && count($request_params) > 0 && (!array_key_exists('query', $p_request_url) || empty($p_request_url['query']))) {
	$request_url .= '?' . http_build_query($request_params);
}

// let the request begin
$ch = curl_init($request_url);
//csajax_debug_message(var_dump($request_params));
curl_setopt($ch, CURLOPT_HTTPHEADER, $request_headers);
// (re-)send headers
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
// return response
curl_setopt($ch, CURLOPT_HEADER, true);
// enabled response headers
// add post data for POST requests
if ($request_method == 'POST') {
	curl_setopt($ch, CURLOPT_POST, true);
	$payload = file_get_contents("php://input");
	//csajax_debug_message(var_dump($payload));
    curl_setopt( $ch, CURLOPT_POSTFIELDS, $payload );
	//curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($request_params));//

}
//csajax_debug_message(var_dump($ch));//json_encode(, JSON_FORCE_OBJECT))
if (preg_match('/(?i)msie [1-8]/', $_SERVER['HTTP_USER_AGENT']) && (strpos($request_url, 'XML_DM_REQUEST') != false  || strpos($request_url, 'XML_COORD_REQUEST') != false  || strpos($request_url, 'XML_STOP_INFO_REQUEST') != false )) {
	curl_setopt($ch, CURLOPT_ENCODING, 'UTF-8');
}

// retrieve response (headers and content)
$response = curl_exec($ch);
curl_close($ch);

// split response to header and content
list($response_headers, $response_content) = preg_split('/(\r\n){2}/', $response, 2);
$content = print_r($ch, true);


// TODO NOT USED?!
//$fp = fopen('leeredatei.txt', 'w');
//fputs($fp, $request_url);
//fclose($fp);


// (re-)send the headers
$response_headers = preg_split('/(\r\n){1}/', $response_headers);

foreach ($response_headers as $key => $response_header) {
	if (!preg_match('/^(Transfer-Encoding):/', $response_header)) {

		if (preg_match('/(?i)msie [1-8]/', $_SERVER['HTTP_USER_AGENT']) && (strpos($request_url, 'XML_DM_REQUEST') != false  || strpos($request_url, 'XML_COORD_REQUEST') != false  || strpos($request_url, 'XML_STOP_INFO_REQUEST') != false )) {
			header('Content-type: text/xml; charset=ISO-8859-1');
		} else {
			header($response_header);
		}

	}
}

// finally, output the content
print($response_content);


// TODO NOT USED?!
//function utf8Encode($data) {
	//return utf8_encode ($data );
	//return iconv("ISO-8859-1", "UTF-8", $data);
//}


function csajax_debug_message($message) {
	if (true == CSAJAX_DEBUG) {
		print $message . PHP_EOL;
	}
}
