cordova.define("projektionisten.cordova.plugin.mobileshop.MobileShop", function(require, exports, module) {
"use strict";

function MobileShop() { }

MobileShop.prototype.showShop = function (shopSettings, successCallback, errorCallback, clickCallback) {
  MobileShop.prototype.clickCallback = clickCallback;
  if (navigator.userAgent && /iPhone|iPad|iPod/.test(navigator.userAgent)) {
    cordova.exec(successCallback, errorCallback, 'MobileShop', 'showShop', [JSON.stringify(shopSettings.ticketInfo)]);
  } else {
    if (shopSettings.ticketInfo !== undefined && shopSettings.ticketInfo.ticketId !== undefined) {
      cordova.exec(successCallback, errorCallback, 'MobileShop', 'showShop', ['showProduct', shopSettings.tabConfig, JSON.stringify(shopSettings.ticketInfo)]);
    } else {
      cordova.exec(successCallback, errorCallback, 'MobileShop', 'showShop', ['showTicketListScreen', shopSettings.tabConfig, JSON.stringify(shopSettings.ticketInfo)]);
    }
  }
};

MobileShop.prototype.registerWidgetListener = function () {
  if (navigator.userAgent && /iPhone|iPad|iPod/.test(navigator.userAgent)) {
    cordova.exec(null, null, 'MobileShop', 'registerWidgetListener', ['back', '']);
  }
};

MobileShop.prototype.setNavCallback = function (navCallback) {
   MobileShop.prototype.navCallback = navCallback;
};

MobileShop.prototype.showTicket = function (shopSettings, successCallback, errorCallback, clickCallback) {
  MobileShop.prototype.clickCallback = clickCallback;
  if (navigator.userAgent && /iPhone|iPad|iPod/.test(navigator.userAgent)) {
    cordova.exec(successCallback, errorCallback, 'MobileShop', 'showTicket', ['back', 'shop-1711009']);
  }
};

MobileShop.prototype.closeShop = function () {
  cordova.exec(null, null, 'MobileShop', 'closeShop', []);
};

MobileShop.install = function () {
  if (!window.plugins) {
    window.plugins = {};
  }
  if (window.broadcaster) {

    window.broadcaster.addEventListener("selectShopTab", function (e) {
        if (MobileShop.prototype.navCallback) {
            MobileShop.prototype.navCallback(false);
        }
    });
    window.broadcaster.addEventListener("ticketAvailable", function (e) {
      cordova.exec(function () { }, function () { }, 'MobileShop', 'showShop', [JSON.stringify({
        backButtonText: 'back'
      })]);
    });
    window.broadcaster.addEventListener("tabClicked", function (e) {
      if (MobileShop.prototype.clickCallback) {
        MobileShop.prototype.clickCallback(e);
      }
    });
    window.broadcaster.addEventListener("shopClosed", function (e) {
      if (MobileShop.prototype.navCallback) {
        MobileShop.prototype.navCallback(true,e["data"]=="more");
      }
    });
  }
  window.plugins.mobileshop = new MobileShop();
  document.dispatchEvent(new Event('onMobileShopReady'));
  return window.plugins.mobileshop;
};

cordova.addConstructor(MobileShop.install);

});
